Bug 1001535 - JarClassLoader warning are displayed after starting s-ramp cli
JarClassLoader warning are displayed after starting s-ramp cli
Status: MODIFIED
Product: JBoss Fuse Service Works 6
Classification: JBoss
Component: DT Governance (Show other bugs)
6.0.0
Unspecified Unspecified
unspecified Severity high
: ER3
: FUTURE
Assigned To: Stefan Bunciak
Matej Melko
:
: 1018268 (view as bug list)
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-08-27 04:59 EDT by Stefan Bunciak
Modified: 2018-03-29 17:51 EDT (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
If you launch the S-RAMP command line interface via s-ramp.sh, you will see a JarClassLoader warning. This is because both commons-beanutils and commons-collections are included in the JAR file for the command line interface and the commons-beanutils library includes the FastHashMap class causing a classname conflict. This warning has no impact on product operation for users and can be ignored.
Story Points: ---
Clone Of:
Environment:
Last Closed:
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Stefan Bunciak 2013-08-27 04:59:02 EDT
Description of problem:
* JarClassLoader warning are displayed after starting s-ramp cli installed via s-ramp installer.

Version-Release number of selected component (if applicable):
* 6.0.0.ER1

How reproducible:
* Always

Steps to Reproduce:
1. Install S-RAMP 6.0.0.ER1 via installer on top of the jboss-eap-6.1
2. Launch s-ramp.sh from installed server bin directory (I had to run 'chmod +x s-ramp.sh' before launching s-ramp cli)

Actual results:

[sbunciak@sbunciak-ntb bin]$ ./s-ramp.sh
JarClassLoader: Warning: org/apache/commons/collections/FastHashMap$CollectionView$CollectionViewIterator.class in lib/commons-beanutils-1.8.3-redhat-2.jar is hidden by lib/commons-collections-3.2.1-redhat-2.jar (with different bytecode)
JarClassLoader: Warning: org/apache/commons/collections/FastHashMap$KeySet.class in lib/commons-beanutils-1.8.3-redhat-2.jar is hidden by lib/commons-collections-3.2.1-redhat-2.jar (with different bytecode)
JarClassLoader: Warning: org/apache/commons/collections/FastHashMap$CollectionView.class in lib/commons-beanutils-1.8.3-redhat-2.jar is hidden by lib/commons-collections-3.2.1-redhat-2.jar (with different bytecode)
JarClassLoader: Warning: org/apache/commons/collections/ArrayStack.class in lib/commons-beanutils-1.8.3-redhat-2.jar is hidden by lib/commons-collections-3.2.1-redhat-2.jar (with different bytecode)
JarClassLoader: Warning: org/apache/commons/collections/FastHashMap.class in lib/commons-beanutils-1.8.3-redhat-2.jar is hidden by lib/commons-collections-3.2.1-redhat-2.jar (with different bytecode)
JarClassLoader: Warning: org/apache/commons/collections/FastHashMap$EntrySet.class in lib/commons-beanutils-1.8.3-redhat-2.jar is hidden by lib/commons-collections-3.2.1-redhat-2.jar (with different bytecode)
JarClassLoader: Warning: org/apache/commons/collections/FastHashMap$Values.class in lib/commons-beanutils-1.8.3-redhat-2.jar is hidden by lib/commons-collections-3.2.1-redhat-2.jar (with different bytecode)
**********************************************************************
           _____       ______  ___ ___  ________  
          /  ___|      | ___ \/ _ \|  \/  | ___ \ 
          \ `--. ______| |_/ / /_\ \ .  . | |_/ / 
           `--. \______|    /|  _  | |\/| |  __/  
          /\__/ /      | |\ \| | | | |  | | |     
          \____/       \_| \_\_| |_|_|  |_|_|     
                                                  
  JBoss S-RAMP Kurt Stam and Eric Wittmann, Licensed under the
  Apache License, V2.0, Copyright 2012
**********************************************************************


Expected results:

* No ClassLoader warnings present

Additional info:
Comment 1 Eric Wittmann 2013-08-30 15:17:22 EDT
The issue here is that commons-beanutils *and* commons-collections are both included in the CLI JAR.  This is problematic because commons-beanutils (for some reason) includes the FastHashMap class (with the same package name!).  It's a naughty Apache project...

This seems like a productization problem (I think) because the s-ramp community CLI build doesn't include commons-beanutils.jar *or* commons-collections.jar!

See output below:

[ewittman@condor 1001535]$ ls
s-ramp-shell-0.3.0.Final.jar  s-ramp-shell-0.3.0.Final-redhat-1.jar
[ewittman@condor 1001535]$ unzip -l s-ramp-shell-0.3.0.Final.jar | grep commons
   354491  07-17-2013 08:33   lib/commons-configuration-1.8.jar
   284220  07-17-2013 08:33   lib/commons-lang-2.6.jar
    60686  07-17-2013 08:33   lib/commons-logging-1.1.1.jar
   241367  07-17-2013 08:33   lib/commons-compress-1.4.1.jar
    58160  07-17-2013 08:33   lib/commons-codec-1.4.jar
   185140  07-17-2013 08:33   lib/commons-io-2.4.jar
[ewittman@condor 1001535]$ unzip -l s-ramp-shell-0.3.0.Final-redhat-1.jar | grep commons
   314120  08-02-2013 10:17   lib/commons-configuration-1.6-redhat-2.jar
   600258  08-02-2013 10:17   lib/commons-collections-3.2.1-redhat-2.jar
   287477  08-02-2013 10:17   lib/commons-lang-2.6-redhat-2.jar
   233203  08-02-2013 10:17   lib/commons-beanutils-1.8.3-redhat-2.jar
   271729  08-02-2013 10:17   lib/commons-compress-1.5-redhat-1.jar
    22183  08-02-2013 10:17   lib/istack-commons-runtime-2.6.1-redhat-2.jar
    65085  08-02-2013 10:17   lib/commons-codec-1.4-redhat-2.jar
   175256  08-02-2013 10:17   lib/commons-io-2.1-redhat-2.jar
Comment 5 Eric Wittmann 2013-10-24 09:03:31 EDT
*** Bug 1018268 has been marked as a duplicate of this bug. ***
Comment 6 Eric Wittmann 2013-11-08 14:08:45 EST
Good news - I think the change to using the platform BOM may have taken care of this bug.  It needs to be re-tested with ER7.

Note You need to log in before you can comment on or make changes to this bug.